#define F_CPU 3276800UL   

#include <avr/io.h>
#include <string.h>
#include <stdio.h> 
#include <util/delay.h>
#include <stdint.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>


unsigned char hodnota;
char buf[8],rx;
short unsigned int cas,seg,dig,cnt,sto,des,jed,i,cnt2; 
float tep;

//********************************************************************
//************************ 7 SEGMENT *********************************
//********************************************************************

void Mask_seg	(seg) {					//funkce zobrazovn slic 1 - 10
	switch (seg)	
	{
	case 0:	  //.gfedcba
		{
		PORTB=0b11000000;
			  //g	
		PORTD=0x80;
		}		
    break;
	case 1:
		{
		PORTB=0b11111001;
		PORTD=0x80;
		}
	break;
	case 2:
		{
		PORTB=0b10100100;
		PORTD=0x00;
		}
	break;
	case 3:
		{
		PORTB=0b10110000;
		PORTD=0x00;
		}
	break;
	case 4:
		{
		PORTB=0b10011001;
		PORTD=0x00;
		}
	break;
	case 5:
		{
		PORTB=0b10010010;
		PORTD=0x00;
		}
	break;
	case 6:
		{
		PORTB=0b10000010;
		PORTD=0x00;
		}
	break;
	case 7:
		{
		PORTB=0b11111000;
		PORTD=0x80;
		}
	break;
	case 8:
		{
		PORTB=0b10000000;
		PORTD=0x00;
		}
	break;
	case 9:
		{
		PORTB=0b10011000;
		PORTD=0x00;
		}
	break;
	case 10:						//slice 10 funguje jako vymazn displeje
		{
		PORTB=0b11111111;
		PORTD|=0x80;
		}
	break;		
	}
		}

void Mask_dig(dig)	{				//funkce pro vybrn jednotlivch slic
	switch (dig)
	{
	case 1:
		{	
		PORTC=0b00000110;
		}
	break;
	case 2: 
		{
		PORTC=0b00000101;
		}
	break;
	case 3: 
		{
		PORTC=0b00000011;
		}
	break;
	}
					}
void clear_seg (void)		//Setting all to "10"
	{
	 PORTC=0b00000110;
	 PORTB=0xFF;
	 PORTD=0x80;
   	 PORTC=0b00000101;
	 PORTB=0xFF;
	 PORTD=0x80;
	 PORTC=0b00000011;
	 PORTB=0xFF;
	 PORTD=0x80;
	 PORTC=0b00000111;	
	}

//********************************************************************
//******************************* UART *******************************
//********************************************************************



void u_puts( char *text );                  //napi string do UART

void uart_init (void)						//inicializace sriov komunikace
{
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x98; 								//Nastaven registru UCSRB s ohledem k zapnut peruen
UCSRC=0x06;
UBRRH=0x00;
UBRRL=0x14;
}

void u_putc( char data )					//Posln znaku sriovou komunikac
	{
	while ( !( UCSRA & (1<<UDRE)) ) ;   
	UDR = data;                         
	}


void u_puts( char *text )					//posln etzce Sriovou komunikac
	{
	unsigned char i=0,temp;

	do
	{
	temp = text[i];
	if(temp==0) break;
	u_putc(temp);
	i++;
	}
	while(temp>0);
	}

void send_temp(void)						//posln hodnoty teploty po vydn uivatelem
	{
		int a=sto*10+des;
 		u_puts("Teplota je: ");		
		sprintf(buf,"%d",a);
		u_puts(buf);
		u_putc(0x2E);
		sprintf(buf,"%d",jed);
		u_puts(buf);
		u_puts(" C");
		u_puts("\r\n");
	}

//********************************************************************
//*************************** AD *************************************
//********************************************************************

void read_adc(void)							//zatek konverze AD pevodnku
  {    
  ADCSRA|=(1<<ADSC); 			
  }

void adc_init(void)
	{	
	ADCSRA = (1 << ADPS2) | (1<<ADPS0);		//nastaven peddliky AD pevodnku na 32 pro frekvenci 102,4 kHz
	ACSR=(1<<ACD);							//vypnut analogovho kompartoru pro ueten energie
	ADCSRA &= (1<<ADFR);
	SFIOR=0x00;		
	ADCSRA |= (1<<ADEN);					//Povolen AD pevodnku		
	ADMUX|=(1<<MUX2);						//Nastaven pevodnku na pin ADC4
	ADMUX|=(1<<REFS0)|(1<<REFS1);			//Zapnut vnitn reference 2,56 V
	ADCSRA |= (1<<ADIE);					//Povolen peruen po dokonen pevodu AD pevodnku
	}


//********************************************************************
//*************************** EXTERNAL INTERRUPT *********************
//********************************************************************

void ex_int_init(void)						//Inicializace externho peruen pro tlatko zapnut displeje
{
GICR=(1<<INT0);								//povolen externho peruen
MCUCR=(1<<ISC01) | (1<<ISC00);				//extern peruen 0 na pinu INT0 pi nbn hran
}

//********************************************************************
//*************************** 8 bit TIMER ****************************
//********************************************************************

void timer_init(void)						//inicializace 8 bitovho timeru pro multiplexovn dipleje
{
TCCR0 = (1<<CS00) | (1<<CS01);				//peddlika 64
TIMSK |=(1<<TOIE0);							//povolen peruen pi peteen registru timeru0
}

void timer_deactiv(void)					//funkce pro vypnut timeru0
{
TCCR0 = 0x00;					
}

//********************************************************************
//************************** 16 bit TIMER ****************************
//********************************************************************

void timer16_init(void)						//inicializace 16 bitovho timeru pro men teploty
{
TCCR1B = (1<<WGM12);						//zapnut komparanho mdu
OCR1A = 16000;								//peruen pi hodnot timeru 16000/ 5s
TIMSK |= (1<<OCIE1A); 						//povolen peruen pi shod registru OCR1A s hodnotou timeru
TCCR1B |= (1<<CS12) | (1<<CS10);			//peddlika 1024 a zapnut timeru
}


//********************************************************************
//************************** Display temp ****************************
//********************************************************************

void display_temp(void)								//funkce pro zobrazen teploty na displeji
	{
		cnt++;

			if (cnt==1)								//Vybrn prvn slice
								{
								Mask_dig(1);
			if  (tep<100)		Mask_seg(10);		//Pokud je hodnota teploty men ne 10 je prvn slice vypnuta
				else			Mask_seg(sto);
								}
			if (cnt==2)								//Druh slice
								{
								Mask_dig(2);								
				if (tep<10)		Mask_seg(10);
				else			Mask_seg(des);
								}
			if (cnt==3)								//Posledn slice a vymazn potadla vybrn slic
				 				{		
								Mask_dig(3);								
								Mask_seg(jed);
								cnt=0;										
								}
	}

//********************************************************************
//*************************** MAIN ***********************************
//********************************************************************


int main(void)
{
DDRD=0xE0;									//Inicializace sti portu D jako vstup
PORTD &=(1<<PORTD2);						//nastaven hodnoty pinu INT0
DDRB=0xFF;									//Nastaven portu B jako vstup pro displej
DDRC=0x07;									//Nastaven portu C jako vstup pro displej

//********************************************************************
//*******************Peripherals initialization **********************
//********************************************************************

timer16_init();								//Inicializace periferi
uart_init();
ex_int_init();
adc_init();
sei();		       

while (1)
      {

			
      };
}

ISR (ADC_vect)								//rutina peruen dokonen AD pevodnku
{

	if (cnt2<10)							//cyklus 10 men AD pevodnku
		{
		i=ADCW;
		tep=tep+((((i/(1024/2.56))-0.5)*1000));	
		cnt2++;
		
		if (cnt2==10)						//vpoet teploty po dokonen vech men
			{
			cnt2=0;
			tep=tep/10;	
			sto=tep/100;
			des=((tep/10)-(sto*10));
			jed=tep-((des*10)+(sto*100));
			tep=0;
			}
	
		}

}

ISR(INT0_vect)								//rutina externho peruen
{

timer_init();
	
}

ISR(TIMER1_COMPA_vect)						//rutina peruen 16 bitovho timeru kadch 5s
{
		read_adc();
				
}


ISR(TIMER0_OVF_vect)						//rutina peteen 8 bitovho timeru			
	{

		if (cas<800) 						//zobrazen teploty na displeji po dobu 4s
			{
			cas++;			
			display_temp();			
			}
		else 
			{
			cas=0;
			clear_seg();
			timer_deactiv();	
			}
	}


ISR(USART_RXC_vect)							//rutina peruen pijatho znaku sriov komunikace
{

rx=UDR;
if (rx==0x74)								//podmnka pijet znaku "t" pro odesln aktuln teploty
	{
	send_temp();
	}
}

